// Variables used by Scriptable.
// These must be at the very top of the file. Do not edit.
// icon-color: light-gray; icon-glyph: link;
"use strict";

const Shortcut = importModule("./lib/index.js");
const url = importModule("./lib/object/url.js");
function process(host, path) {
    const processors = {
        "amazon.com": path => (([, pid = null]) => pid === null ? path : `/dp/${pid.split("/")[0]}`)(path.split("/dp/")),
        "dropbox.com": path => !path.startsWith("/scl/fi/") ? path : (nodes => nodes.length < 4 ? path : nodes.slice(0, 4).join("/"))(path.split("/")),
        "linkedin.com": path => path.startsWith("/mwlite/") ? path.slice(7) : path,
        "reddit.com": path => (nodes => nodes.length < 6 || nodes[3] !== "comments" ? path : nodes.slice(0, nodes[5] === "comment" ? 7 : 5).join("/"))(path.split("/")),
    };
    return processors[host]?.(path) ?? path;
}
class Link extends Shortcut {
    stringInput = true;
    runtime() {
        const { setting: { hosts, queries, fragments }, input = "", } = this, { scheme, host: _host, path, query, fragment, } = url(input), host = ((host) => (headless => hosts.swap[headless] ?? headless)(!host.startsWith("www.") || hosts.preserve.includes(host) ? host : host.slice(4)))(_host), [include = null, exclude = null,] = ["include", "exclude"].map(group => queries[group][host]?.map(i => i.toLowerCase()));
        return (({ scheme, host, path, query, fragment, }) => `${scheme}${scheme === "" ? "" : "://"}${host}${path === "/" ? "" : path}${query === "" ? "" : "?"}${query}${fragment === "" ? "" : "#"}${fragment}`)({
            scheme,
            host,
            path: process(host, path),
            query: queries.remove.includes(host)
                ? ""
                : include !== null
                    ? query
                        .split("&")
                        .map(term => term.split("="))
                        .filter(([key]) => include.includes(key.toLowerCase()))
                        .map(tuple => tuple.join("="))
                        .join("&")
                    : exclude !== null
                        ? query
                            .split("&")
                            .map(term => term.split("="))
                            .filter(([key]) => !exclude.includes(key.toLowerCase()))
                            .map(tuple => tuple.join("="))
                            .join("&")
                        : query,
            fragment: fragments.trim.includes(host) ? "" : fragment,
        });
    }
}
new Link().run();

