// Variables used by Scriptable.
// These must be at the very top of the file. Do not edit.
// icon-color: blue; icon-glyph: search;
"use strict";

const Shortcut = importModule("./lib/index.js");
const Query = importModule("./helper/search/query.js");
const Engine = importModule("./helper/search/engine.js");
class Search extends Shortcut {
    stringInput = true;
    runtime() {
        const { tags: { query: tag }, engines, alias, reserved: { selector, operators, }, defaults: { math, translate, fallback, }, } = this.setting, { input = "" } = this, string = input === "" ? this.read() : input, { key, terms, question, recomposed, } = Query(string, engines, alias, ...Search.stringfuls([
            selector,
            operators,
            math,
            translate,
        ]), Search.stringfuls(fallback)), entry = engines[key], engine = Array.isArray(entry) || typeof entry === "string"
            ? new Engine("browser", entry, tag)
            : "url" in entry
                ? new Engine("browser", entry.url, tag, entry.separator, entry.encodeComponent, entry.force)
                : "api" in entry
                    ? new Engine("api", entry.api, tag, entry.separator, entry.encodeComponent)
                    : "shortcut" in entry
                        ? new Engine("shortcut", entry.shortcut, entry.output)
                        : new Engine("find", entry.find);
        this.write(recomposed);
        return engine.resolve(key, terms, question);
    }
}
new Search().run();

